/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#if 0

#define MODULE_NAME "sostype"
#define COPYRIGHT   "1995 SOS GmbH Berlin"
#define AUTHOR      "Joacim Zschimmer"

#include <sos.h>
#include <sostype.h>

typedef unsigned long int ulong;

extern const Fundamental_type type_char     ( Fundamental_type::plain_char , sizeof (char)     );
extern const Fundamental_type type_int      ( Fundamental_type::plain_int  , sizeof (int)      );
extern const Fundamental_type type_int1     ( Fundamental_type::plain_int  , sizeof (int1)     );
extern const Fundamental_type type_int2     ( Fundamental_type::plain_int  , sizeof (int2)     );
extern const Fundamental_type type_int4     ( Fundamental_type::plain_int  , sizeof (int4)     );
extern const Fundamental_type type_long     ( Fundamental_type::plain_int  , sizeof (long)     );
extern const Fundamental_type type_uint     ( Fundamental_type::plain_int  , sizeof (uint)     );
extern const Fundamental_type type_uint1    ( Fundamental_type::plain_int  , sizeof (uint1)    );
extern const Fundamental_type type_uint2    ( Fundamental_type::plain_int  , sizeof (uint2)    );
extern const Fundamental_type type_uint4    ( Fundamental_type::plain_int  , sizeof (uint4)    );
extern const Fundamental_type type_ulong    ( Fundamental_type::plain_int  , sizeof (ulong)    );

///////////////////////////////////////////////////////////////////////////////////////////////

struct X : Sos_self_deleting
{
    const Sos_type&            _obj_type                () const;

  private:
    int                        _a;
    int                        _b;
};

struct Test : Sos_self_deleting
{
    const Sos_type&            _obj_type                () const;

  private:
    static const Struct_type   _type;

    int                        _integer;
    char                       _char;
    X                          _x;
};

const Struct_type Test::_type

void add_member( Struct_type*, const int* , const char* name, const char* ext_name = "" );
void add_member( Struct_type*, const char*, const char* name, const char* ext_name = "" );
void add_member( Struct_type*, const X*   , const char* name, const char* ext_name = "" );

template< class TYPE >
void add_member( Struct_type*, const char* name, const Sos_ptr<TYPE>* );

template< class TYPE >
void add_member( Struct_type*, const char* name, const TYPE* );  // NICHT DEFINIERT

#define TYPE_ADD_MEMBER    ( NAME )            add_member( t, &o->NAME, #NAME, #NAME )
#define TYPE_ADD_MEMBER_EXT( NAME, EXT_NAME )  add_member( t, &o->NAME, #NAME, #EXT_NAME )

void add_member( Struct_type* t, const int* offset, const char* name, const char* ext_name )
{
    t->add_member( Struct_member_decr( &type_int, (int)offset, name, ext_name ) );   // Record_type/Field_type?
}

void xx()
{
    Struct_type* t = &_type;
    const Test*  o = 0;

    TYPE_ADD_MEMBER_EXT( _integer, "xy_integer" );
    TYPE_ADD_MEMBER    ( _char   );
    TYPE_ADD_MEMBER    ( _x      );
}


const Sos_type& Test::_obj_type() const
{
    return _type;
}


