/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
//#define MODULE_NAME "sysfile"
// sysfile.cpp

#include <precomp.h>

#if 0

#include <process.h>
#include <xception.h>
#include <nullasgn.h>
#include <string.h>

#include "sysfile.h"

extern int errno;

//-------------------------------------------------------System_file_type
struct System_file_type : Abs_file_type
{
    System_file_type() : Abs_file_type() {};

    virtual const char* name() const { return "system"; }

    virtual Bool is_record_file()  const { return true; }

    virtual Abs_file_base* create_base_file() const { return new System_file(); }

    virtual Abs_record_file* create_record_file() const { return new System_file(); }

};

static System_file_type _System_file_type;

const Abs_file_type& System_file::static_file_type () {
  return _System_file_type;
};

//

System_file::System_file( Const_string0_ptr cmd ) {
   open( cmd ); xc;
exceptions
};

void System_file::open( Const_string0_ptr cmd, Open_mode ) {
   dos_command( cmd ); xc;
exceptions
};

void System_file::close( Close_mode ) {
};

void System_file::put_record( Const_area area ) {
   char *buf = new char[ area.length() + 1 ];
      if (!buf) raise( "R101", "NOMEMORY" );
   memcpy( buf, area.char_ptr(), area.length() );
   buf[area.length()] = 0;

   dos_command( buf ); xc;
   delete [] buf;  buf = 0;
exceptions
   delete [] buf;  buf = 0;
};

void System_file::get_record( Area& ) {
};

void System_file::dos_command( Const_string0_ptr cmd ) {
   if ( !check_dos_command( cmd ) ) {
      return;
   };
   if ( system( cmd ) == -1 ) {
      raise_errno( errno );
   };
   null_pointer_assignment.init();
exceptions
};

Bool System_file::check_dos_command( Const_string0_ptr cmd ) {
   Const_string0_ptr ptr = cmd;
   while ( *ptr == ' ' ) ptr++;
   if ( strcspn( ptr, " \r\n\t" ) == 0 ) {
     return false;
   } else {
     return true;
   };
};

#endif

